from .json_out import JSONOut
from .mongodb import MongoDB
from .csv_out import CSVOut
from .sql_out import SQLOut
from .text_out import TextOut
from .wget import Wget

CLASSES = {
    'csv': CSVOut,
    'json': JSONOut,
    'mongodb': MongoDB,
    'sql': SQLOut,
    'text': TextOut,
    'wget': Wget
}


def output_for(s):
    spec_args = s.split(':', 1)
    clz = CLASSES.get(spec_args[0])
    if not clz:
        raise NoSuchOutputException(spec_args[0])
    return clz() if len(spec_args) == 1 else clz(spec_args[1])


class NoSuchOutputException(Exception):
    def __init__(self, value):
        self.value = value

    def __str__(self):
        return repr(self.value)